const { url } = require("../config_base");
function requireFunc(urlType: string, data: requireFuncDate) {
  return new Promise((resolve, reject) => {
    wx.request({
      url: url + urlType,
      data,
      // enableHttp2: true,
      method: "POST",
      success: (res: wxRequire) => {
        if (res.statusCode !== 200 || res.data.code !== 0) wx.showToast({ title: res.data.message || '请求出错', icon: 'none' }), reject(res.data.message)
        resolve(res.data.data);
      },
      fail(err) {
        reject(err);
      },
      complete() {
        wx.hideLoading();
      }
    })
  })
}
const api = {
  getChannel() {
    return requireFunc("/ad/channel", {})
  },
  getDay(data: requireFuncDate) {
    return requireFunc("/ad/day", data)
  },
  getHour(data: requireFuncDate) {
    return requireFunc("/ad/hour", data)
  },
  getRatio(data: requireFuncDate) {
    return requireFunc("/ad/ratio", data)
  },
  getDetail(data: requireFuncDate) {
    return requireFunc("/ad/detail", data)
  },
  getYoushi(data: requireFuncDate) {
    return requireFunc("/ad/youshi", data)
  },
  getQianzai(data: requireFuncDate) {
    return requireFunc("/ad/qianzai", data)
  },
  getSaturation(data: requireFuncDate) {
    return requireFunc("/ad/saturation", data)
  },
  getIndustry(data: requireFuncDate) {
    return requireFunc("/ad/industry/list", data)
  },
  getMarket(data: requireFuncDate) {
    return requireFunc("/ad/market", data)
  },

  
  getTrendHard(data: requireFuncDate) {
    return requireFunc("/ad/industry/TrendHard", data)
  },
  getTrendSoft(data: requireFuncDate) {
    return requireFunc("/ad/industry/TrendSoft", data)
  },
  getMSIndustryProportion(data: requireFuncDate) {
    return requireFunc("/ad/industry/MSIndustryProportion", data)
  },
  getChannelDistribution(data: requireFuncDate) {
    return requireFunc("/ad/industry/ChannelDistribution", data)
  },
  getImportantCustomer(data: requireFuncDate) {
    return requireFunc("/ad/industry/ImportantCustomer", data)
  },
  getProgramTypeDistribution(data: requireFuncDate) {
    return requireFunc("/ad/industry/ProgramTypeDistribution", data)
  },
  getLastWeekTrend(data: requireFuncDate) {
    return requireFunc("/ad/industry/LastWeekTrend", data)
  },
}

module.exports = api;
